#include<iostream>
#include<vector>
#include<tuple>
using namespace std;

const int MAXN=2e3, MAXD=MAXN+1, INF=1e9;

int n, m;
int dp[MAXN][MAXD];
bool active[MAXN][MAXD], v[MAXN];
vector<tuple<int, int, int> > graph[MAXN];

bool DFS(int idx)
{
    if(v[idx])
    {
        return false;
    }

    if(idx==n-1)
    {
        return true;
    }

    v[idx]=true;
    for(tuple<int, int, int> t:graph[idx])
    {
        int node, x, y;
        tie(node, x, y)=t;

        if(DFS(node))
        {
            return true;
        }
    }

    return false;
}

int GetAns(int idx, int d)
{
    if(active[idx][d])
    {
        return INF;
    }

    if(dp[idx][d]!=INF)
    {
        return dp[idx][d];
    }

    if(idx==n-1)
    {
        return 0;
    }

    active[idx][d]=true;
    for(tuple<int, int, int> t:graph[idx])
    {
        int node, x, y;
        tie(node, x, y)=t;

        if(d>=x)
        {
            dp[idx][d]=min(dp[idx][d], GetAns(node, min(MAXD-1, d+y-x)));
        }
        else
        {
            dp[idx][d]=min(dp[idx][d], x-d+GetAns(node, y));
        }
    }
    active[idx][d]=false;

    return dp[idx][d];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    for(int i=0; i<m; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--;

        graph[a].push_back({b, c, d});
    }

    for(int i=0; i<n; i++)
    {
        v[i]=false;
    }

    if(!DFS(0))
    {
        cout << "-1\n";
    }
    else
    {
        for(int i=0; i<n; i++)
        {
            for(int j=0; j<MAXD; j++)
            {
                dp[i][j]=INF, active[i][j]=false;
            }
        }

        cout << GetAns(0, 0) << "\n";
    }

    return 0;
}
