#include<iostream>
#include<vector>
#include<queue>
#include<tuple>
using namespace std;

const int MAXN=100, MAXD=30*MAXN, INF=1e9;

int n, m;
bool v[MAXN], dp[MAXN][MAXD+1];
vector<tuple<int, int, int> > graph[MAXN];

void DFS(int idx)
{
    if(v[idx])
    {
        return;
    }

    v[idx]=true;
    for(tuple<int, int, int> t:graph[idx])
    {
        int node, x, y;
        tie(node, x, y)=t;

        DFS(node);
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;

    for(int i=0; i<m; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--;

        graph[a].push_back({b, c, d});
    }

    for(int i=0; i<n; i++)
    {
        v[i]=false;
    }

    DFS(0);

    if(!v[n-1])
    {
        cout << "-1\n";
    }
    else
    {
        priority_queue<tuple<int, int, int> > q;
        q.push({0, 0, 0});

        int ans=INF;
        while(!q.empty())
        {
            int d, x, idx;
            tie(d, x, idx)=q.top();
            d*=-1;
            q.pop();

            if(dp[idx][x])
            {
                continue;
            }

            if(idx==n-1)
            {
                ans=min(ans, d);
                continue;
            }

            dp[idx][x]=true;

            for(tuple<int, int, int> t:graph[idx])
            {
                int node, c, y;
                tie(node, c, y)=t;

                if(x>=c)
                {
                    q.push({-d, min(MAXD, y+x-c), node});
                }
                else
                {
                    q.push({-(d+c-x), y, node});
                }
            }
        }

        cout << ans << "\n";
    }

    return 0;
}
