#include <bits/stdc++.h>
#define endl '\n'
#define MOD 1000000007
#define MAXN 3003
using namespace std;
typedef long long ll;
ll n, m, k, a, b;
ll cnt_x[MAXN][MAXN];
ll cnt_y[MAXN][MAXN];

void input()
{
    cin >> n >> m >> a >> b >> k;
}

ll tree[MAXN << 2][MAXN];

void merge_v(int v, int idx)
{
    tree[v][idx] = (tree[v << 1][idx] + tree[(v << 1) + 1][idx]) % MOD;
}

void update(int v, int idx, int l, int r, int pos, ll val)
{
    if (l > pos || r < pos)
        return;

    if (l == r)
    {
        tree[v][idx] = val % MOD;
        return;
    }

    int mid = (l + r) >> 1;
    update(v << 1, idx, l, mid, pos, val);
    update((v << 1) + 1, idx, mid + 1, r, pos, val);
    merge_v(v, idx);
}

ll query(int v, int idx, int l, int r, int x, int y)
{
    if (r < x || l > y)
        return 0;

    if (l >= x && r <= y)
        return tree[v][idx];

    int mid = (l + r) >> 1;
    ll q_left = query(v << 1, idx, l, mid, x, y);
    ll q_right = query((v << 1) + 1, idx, mid + 1, r, x, y);
    return (q_left + q_right) % MOD;
}

void solve()
{
    int idx = 0;
    cnt_x[0][0] = 1;
    update(1, 0, 0, n, 0, 1);
    for (int dist = 0; dist <= n; ++dist)
        for (int moves = 1; moves <= k; ++moves)
        {
            cnt_x[dist][moves] = 0;
            cnt_x[dist][moves] = query(1, moves - 1, 0, n, dist - a, dist);
            //cout << dist << " " << moves << " " << query(1, 0, n, dist - a, dist) << endl;;
            //cout << dist << " - " << moves << ": " << cnt_x[dist][moves] << endl;
            update(1, moves, 0, n, dist, cnt_x[dist][moves]);
            //idx ^= 1;

//            for (int x = 0; x <= a; ++x)
//            {
//                if (dist >= x)
//                {
//                    cnt_x[dist][moves] += cnt_x[dist - x][moves - 1];
//                    cnt_x[dist][moves] %= MOD;
//                }
//            }
        }

    //cout << endl;

    idx = 0;
    cnt_y[0][0] = 1;
    update(1, 0, 0, m, 0, 1);
    for (int dist = 0; dist <= m; ++dist)
        for (int moves = 1; moves <= k; ++moves)
        {
            cnt_y[dist][moves] = 0;
            cnt_y[dist][moves] = query(1, moves - 1, 0, m, dist - b, dist);
            update(1, moves, 0, m, dist, cnt_y[dist][moves]);
//            idx ^= 1;

            //cout << dist << " - " << moves << ": " << cnt_y[dist][moves] << endl;

//            for (int x = 0; x <= b; ++x)
//            {
//                if (dist >= x)
//                {
//                    cnt_y[dist][moves] += cnt_y[dist - x][moves - 1];
//                    cnt_y[dist][moves] %= MOD;
//                }
//            }
        }

    cout << (cnt_x[n][k] * cnt_y[m][k]) % MOD << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
