#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
#define all(x) x.begin(), x.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const ll MOD = 1e9 + 7;
const ll MAXN = 1e6 + 6;

ll n, sz = 0, fact[MAXN];
vector<int> _Q, _P, used;
matrix<int> freq, G;

void dfs(int u){
	used[u] = true;
	++ sz;
	for(auto v : G[u]) if(!used[v]){
		dfs(v);
	}
}

ll solve_slow(vector<int> &Q){
	int n, ans = 0;
	n = Q.size();
	vector<int> P(n);
	for(int i = 0; i < n; i ++) P[i] = i + 1;
	do{
		vector<int> check(n, true);
		if(P[1] != Q[0]) check[0] = false;
		if(P[n - 2] != Q[n - 1]) check[n - 1] = false;
		for(int i = 1; i < n - 1; i ++){
			if(Q[i] != P[i + 1] && Q[i] != P[i - 1]){
				check[i] = false;
			}
		}
		if(count(all(check), false) == 0){
			ans = (ans + 1) % MOD;
		}
	}while(next_permutation(all(P)));
	return ans;
}

ll solve_fast(vector<int> &Q){
	n = Q.size();
	_Q = Q;
	used = _P = vector<int>(n);
	
	G = freq = matrix<int>(n + 1);
	/// for(auto &x : Q) cin >> x;
	/// check frequencies
	for(int i = 0; i < n; i ++){
		freq[_Q[i]].pb(i);
	}
	for(int i = 1; i <= n; i ++){
		if(freq[i].size() > 2){ /**cout << "0\n";*/ return -1; }
		if(freq[i].size() == 2 && abs(freq[i][0] - freq[i][1]) != 2){ /**cout << "0\n";*/ return -2; }
	}
	if(n == 3 && _Q[0] != _Q[n - 1]){ return -3; }
	_P[1] = _Q[0]; _P[n - 2] = _Q[n - 1];
	/// put 1, 3, 5...
	for(int i = 2; i < n; i += 2){
		if(_Q[i] != _P[i - 1] && i + 1 < n){
			_P[i + 1] = _Q[i];
		}
		if(_Q[i] == _P[i - 1]) break;
	}
	/// put n - 2, n - 4, n - 6...
	if(_P[n - 2] != _Q[n - 1] && _P[n - 2] != 0){ return -7; }
	for(int i = n - 3; i >= 0; i -= 2){
		if(_Q[i] != _P[i + 1] && i - 1 >= 0){
			if(_P[i - 1] == 0){
				_P[i - 1] = _Q[i];
			}
			else if(_P[i - 1] != _Q[i]){ /**cout << "0\n";*/ return -4; }
			else{
				break;
			}
		}
		if(_Q[i] == _P[i + 1]){
			break;
		}
	}
	/// put when Q[i - 1] = Q[i + 1]
	for(int i = 1; i < n - 1; i ++){
		if(_Q[i - 1] == _Q[i + 1]){
			if(_P[i] == 0){
				_P[i] = _Q[i - 1];
			}
			else if(_P[i] != _Q[i - 1]){ /**cout << "0\n";*/ return -5; }
		}
	}
	for(int i = 1; i < n - 1; i ++){
		/// cout << i << ": " << _P[i - 1] << " " << _P[i + 1] << " " << Q[i] << endl;
		if((_P[i - 1] != _Q[i] && _P[i - 1] != 0) && (_P[i + 1] != _Q[i] && _P[i + 1] != 0)){
			return -6;
		}
	}
	if(count(all(_P), 0) == 0){ return 1; }
	/// for(auto x : _P) cout << x << " "; cout << endl;
	/// for(auto x : _P) cout << x << " "; cout << endl;
	for(int i = 2; i < n; i ++){
		if(_P[i - 2] == 0 && _P[i] == 0){
			/// cout << i << " -> " << i - 2 << endl;
			G[i].pb(i - 2);
			G[i - 2].pb(i);
		}
	}
	ll ans = 1, cnt = 0;
	for(int u = 0; u < n; u ++){
		if(!used[u] && !_P[u]){
			sz = 0;
			dfs(u);
			++ cnt;
			/// cout << sz << endl;
			ans = (ans * sz) % MOD;
		}
	}
	return (ans * fact[cnt]) % MOD;
}


void init(){
	fact[1] = 1;
	for(ll i = 2; i < MAXN; i ++) fact[i] = (i * fact[i - 1]) % MOD;
}


int main(){
	init();
	/**int bleh = 0;
	srand(time(NULL));
	while(1){
		int n = rand() % 8 + 2;
		vector<int> Q(n);
		for(auto &x : Q) x = rand() % n + 1;
		cout << "save\n";
		cout << n << endl;
		for(auto x : Q) cout << x << " "; cout << endl;
		
		if(max(0LL, solve_fast(Q)) != solve_slow(Q)){
			cout << Q.size() << endl;
			for(auto x : Q) cout << x << " "; cout << endl;
			de(solve_fast(Q));
			de(solve_slow(Q));
			cin.get();
		}
		de(bleh ++);
	}*/
	int _n; cin >> _n;
	vector<int> was(_n);
	for(auto &x : was) cin >> x;
	cout << max(0LL, solve_fast(was)) << endl;
}
/**
5
1 3 1 4 2
3

4
3 1 2 3
0
*/