#include <bits/stdc++.h>

#define ENDL '\n'

namespace {
using num = long long;

template <class T>
using vec = std::vector<T>;

template <class T>
using vec2d = vec<vec<T>>;

template <class T>
using vec3d = vec<vec2d<T>>;

const num mod = 1e9 + 7;

auto solve(num n, num m, num a, num b, num k) {
    vec3d<num> dp(n + 1, vec2d<num>(m + 1, vec<num>(k, -1))); 

    std::function<num(num, num, num)> recurse;
    recurse = [&](num curr_x, num curr_y, num curr_steps) {
        if (curr_x > n || curr_y > m || curr_steps > k) {
            return num(0);
        }

        if (curr_steps == k) {
            return num(curr_x == n && curr_y == m);
        }

        auto& res = dp[curr_x][curr_y][curr_steps]; 
        if (res == -1) {
            res = 0;

            for (num delta_x = 0; delta_x <= a; ++delta_x) {
                for (num delta_y = 0; delta_y <= b; ++delta_y) {
                    res += recurse(curr_x + delta_x, curr_y + delta_y, curr_steps + 1);
                    res %= mod;
                }
            }
        }

        return res;
    };

    return recurse(0, 0, 0);
}
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    num n, m, a, b, k;
    std::cin >> n >> m >> a >> b >> k;

    std::cout << solve(n, m, a, b, k) << ENDL; 

    return 0;
}
