#include <bits/stdc++.h>
#include <cassert>

#define ENDL '\n'

namespace {
template <class T>
using vec = std::vector<T>;

template <class T>
using mat = vec<vec<T>>;

using edge_t = std::pair<int, int>;

using graph_t = mat<edge_t>;

template <class T>
using min_heap_t = std::priority_queue<T, vec<T>, std::greater<T>>;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int n, m;
    std::cin >> n >> m;

    graph_t graph(n);

    int u, v, w, x;
    while (n--) {
        std::cin >> u >> v >> w >> x;
        --u, --v;

        assert(x == 0);

        graph[u].emplace_back(v, w);
    }

    vec<int> dist(graph.size(), std::numeric_limits<int>::max());
    dist[0] = 0;

    min_heap_t<edge_t> q;
    q.emplace(0, 0);

    while (!q.empty()) {
        auto u = q.top().second;
        q.pop();

        for (auto& [v, w] : graph[u]) {
            if (dist[v] > dist[u] + w) {
                dist[v] = dist[u] + w;

                q.emplace(w, v);
            }
        }
    }

    std::cout << dist[graph.size() - 1] << ENDL;
    
    return 0;
}
