#include <bits/stdc++.h>
#include <cassert>

#define ENDL '\n'

namespace {
using num = long long;

template <class T>
using vec = std::vector<T>;

template <class T>
using mat = vec<vec<T>>;

using edge_t = std::tuple<num, num, num>;

using graph_t = mat<edge_t>;

template <class T>
using min_heap_t = std::priority_queue<T, vec<T>, std::greater<T>>;

const num inf = std::numeric_limits<int>::max();
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    num n, m;
    std::cin >> n >> m;

    graph_t graph(n);

    num u, v, w, x;
    while (m--) {
        std::cin >> u >> v >> w >> x;
        --u, --v;

        graph[u].emplace_back(v, w, x);
    }

    vec<num> dist(graph.size(), inf);
    dist[0] = 0;

    min_heap_t<edge_t> q;
    q.emplace(0, 0, 0);

    while (!q.empty()) {
        auto [t, u, curr_x] = q.top();
        q.pop();

        for (auto& [v, w, x] : graph[u]) {
            for (auto i = 0; i <= std::min(curr_x, w); ++i) {
                auto w_with_magic = w - i;

                if (dist[v] > dist[u] + w_with_magic) {
                    dist[v] = dist[u] + w_with_magic;

                    q.emplace(w_with_magic, v, curr_x - i + x);
                }
            }
        }
    }

    auto res = dist[graph.size() - 1];
    std::cout << (res == inf ? -1 : res) << ENDL;
    
    return 0;
}
