#include <bits/stdc++.h>
using namespace std;

const int maxn = 2003, maxm = 5003;
int n, m;
struct edge{
    int to, time, magic;
};
vector <edge> adj [maxn];

struct node{
    int idx, magic, time;
    bool operator < (node oth) const{
        return time > oth.time;
    }
};
int max_magic [maxn];
int dijkstra (){

    priority_queue <node> pq;
    pq.push ({1, 0, 0});
    while (!pq.empty ()){
        auto u = pq.top ();
        pq.pop ();
        if (u.idx == n) return u.time;
        if (max_magic [u.idx] >= u.magic) continue;
        max_magic [u.idx] = u.magic;
        for (edge e : adj [u.idx]){
            int new_magic = max (0, u.magic - e.time) + e.magic;
            if (max_magic [e.to] >= new_magic) continue;
            pq.push ({e.to, new_magic, u.time + max (0, e.time - u.magic)});
        }
    }
    return -1;

}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m;
    for (int i = 1; i <= n; i ++) max_magic [i] = -1;
    for (int i = 0; i < m; i ++){
        int from, to, time, magic;
        cin >> from >> to >> time >> magic;
        adj [from].push_back ({to, time, magic});
    }
    cout << dijkstra () << '\n';

}