#include <bits/stdc++.h>
using namespace std;

const int maxn = 2003, maxm = 5003;
int n, m, max_time = 0;
struct edge{
    int to, time, magic;
};
vector <edge> adj [maxn], rev_adj [maxn];

int dist [maxn];
void rev_bfs (){

    queue <int> q;
    q.push (n);
    while (!q.empty ()){
        int u = q.front ();
        q.pop ();
        for (edge e : rev_adj [u]){
            if (!dist [e.to] && e.to != n){
                dist [e.to] = dist [u] + e.time;
                q.push (e.to);
            }
        }
    }

}

struct node{
    int idx, magic, time;
    bool operator < (node oth) const{
        return time > oth.time;
    }
};
int curr_time [maxn], max_magic [maxn];
int dijkstra (){

    priority_queue <node> pq;
    pq.push ({1, 0, 0});
    while (!pq.empty ()){
        auto u = pq.top ();
        pq.pop ();
        if (u.idx == n || dist [u.idx] > 0 && u.magic >= dist [u.idx]) return u.time;
        if (dist [u.idx] == 0) continue;
        if (max_magic [u.idx] >= u.magic) continue;
        max_magic [u.idx] = u.magic;
        // if (curr_time [u.idx] == u.time) return u.time;
        // curr_time [u.idx] = u.time;
        for (edge e : adj [u.idx]){
            int new_magic = max (0, u.magic - e.time) + e.magic;
            if (max_magic [e.to] >= new_magic) continue;
            pq.push ({e.to, new_magic, u.time + max (0, e.time - u.magic)});
        }
    }
    return -1;

}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m;
    for (int i = 1; i <= n; i ++) max_magic [i] = curr_time [i] = -1;
    for (int i = 0; i < m; i ++){
        int from, to, time, magic;
        cin >> from >> to >> time >> magic;
        adj [from].push_back ({to, time, magic});
        rev_adj [to].push_back ({from, time, magic});
    }
    rev_bfs ();
    cout << dijkstra () << '\n';

}