#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 2003; 
const int maxmagic = 2000 * 30 + 3; 
const int inf = 1e9 + 3; 

struct road {
	int to, dist, magic;
	road(int to, int dist, int magic) {
		this->to = to;
        this->dist = dist;
        this->magic = magic;
	}
};

struct state {
	int ver, magic, cost;
	state(int ver, int magic, int cost) {
		this->ver = ver;
		this->magic = magic;
		this->cost = cost;
	}
	
	bool operator < (const state &other) const {
		return this->cost > other.cost;
	}
};

int n, m; 
vector <road> adj[maxn];
void read()
{
	cin >> n >> m;
	for (int i = 1; i <= m; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		
		adj[a].push_back(road(b, c, d));
	}
}

int cost[maxn][maxmagic];
void dijkstra() {
	for (int i = 1; i <= n; i++)
	for (int j = 0; j <= n * 30; j++)
	cost[i][j] = inf;
	
	priority_queue <state> pq;
	pq.push(state(1, 0, 0));
	cost[1][0] = 0;
	while (!pq.empty()) {
		auto node = pq.top();
		pq.pop();
		
		if (node.cost != cost[node.ver][node.magic])
		continue;
		
		for (auto e: adj[node.ver]) {
			if (node.magic >= e.dist) {
				if (cost[e.to][node.magic - e.dist + e.magic] > node.cost) {
					cost[e.to][node.magic - e.dist + e.magic] = node.cost;
					pq.push(state(e.to, node.magic - e.dist + e.magic, node.cost));
				}
			}
			
			else {
				if (cost[e.to][e.magic] > node.cost + e.dist - node.magic) {
					cost[e.to][e.magic] = node.cost + e.dist - node.magic;
					pq.push(state(e.to, e.magic, node.cost + e.dist - node.magic));
				}
			}
		}		
	}
}

void solve()
{
	dijkstra();
	int ans = inf;
	for (int i = 0; i <= n * 30; i++)
	ans = min(ans, cost[n][i]);
	
	if (ans == inf)
	cout << -1 << endl;
	
	else 
	cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
