#include<iostream>
#include<vector>

using namespace std;

int n;
const int maxn = 1000005;
int q[maxn];
vector<int> indexOfNumber[maxn];  ///indexOfNumber[i] stores the indexes of all numbers i that appear in Q
int state[maxn];  ///state[i] =  0      if there is no i in Q
                  ///state[i] = -1      if there is only one i in Q
                  ///state[i] =  j > 0  if there are two i-s in Q i.e. there is only one possible position for i in P
vector<int> candidateForP[maxn];  ///candidateForP[i] stores all numbers that can be the i-th number in P
vector<int> universalCandidates;  ///all i for which state[i] = 0; there are no restrictions on as to where these numbers can be in P

struct boolArray{
    bool arr[maxn];
};

boolArray used;
long long answer;

void solve(boolArray currUsed, int currPos){

    if(currPos > n) return;

    if(state[currPos] > 0){
        int currNum = state[currPos];

        if(currUsed.arr[currNum]) return;

        boolArray nextUsed = currUsed;
        nextUsed.arr[currNum] = true;
        solve(nextUsed, currPos+1);
        return;
    }

    for(int i=0; i<candidateForP[currPos].size(); i++){
        int currCand = candidateForP[currPos][i];
        if(!currUsed.arr[currCand]){
            if(currPos == n){
                answer++;
                return;
            }
            else{
                boolArray nextUsed = currUsed;
                nextUsed.arr[currCand] = true;
                solve(nextUsed, currPos+1);
            }
        }
    }

    for(int i=0; i<universalCandidates.size(); i++){
        int currCand = universalCandidates[i];
        if(!currUsed.arr[currCand]){
            if(currPos == n){
                answer++;
                return;
            }
            else{
                boolArray nextUsed = currUsed;
                nextUsed.arr[currCand] = true;
                solve(nextUsed, currPos+1);
            }
        }
    }

    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;

    for(int i=1; i<=n; i++){
        cin >> q[i];

        if(i == 1) state[q[i]] = 2;
        else if(i == n) state[q[i]] = n-1;
        else{
            candidateForP[i-1].push_back(q[i]);
            candidateForP[i+1].push_back(q[i]);
        }

        indexOfNumber[q[i]].push_back(i);
        int numberOfIndexes = indexOfNumber[q[i]].size();
        if(numberOfIndexes > 2){
            cout << 0;
            return 0;
        }
        else if(numberOfIndexes == 2){
            int index1 = indexOfNumber[q[i]][0];
            int index2 = indexOfNumber[q[i]][1];
            if(abs(index1 - index2) != 2){  ///i.e. the distance between the two indexes is not 2
                cout << 0;
                return 0;
            }
            else{
                state[q[i]] = (index1 + index2)/2; ///i.e. the only index between index1 and index2
            }
        }
        else{ ///numberOfIndexes = 1
            state[q[i]] = -1;
        }
    }

    for(int i=1; i<=n; i++){
        if(state[i] == 0) universalCandidates.push_back(i);
    }

    solve(used, 1);
    cout << answer << endl;

    return 0;
}
