#include<iostream>
#include<queue>
#include<vector>

using namespace std;

const int maxn = 2005;
vector< pair<int,int> > adj[maxn];

priority_queue< pair<int,int> > frontier;
bool used[maxn];

int main(){

    int n, m;
    cin >> n >> m;

    for(int i=0; i<m; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        adj[a].push_back(make_pair(b, c));
    }

    long long length = 0;
    frontier.push(make_pair(0,1));

    bool successfulEnd = false;

    while(!frontier.empty()){
        int curr = frontier.top().second;
        int addLength = -frontier.top().first;
        frontier.pop();

        if(used[curr]) frontier.pop();
        used[curr] = true;

        length += addLength;

        if(curr == n){
            successfulEnd = true;
            break;
        }

        for(int i=0; i<adj[curr].size(); i++){
            int currNeigh = adj[curr][i].first;
            int currLength = adj[curr][i].second;
            if(used[currNeigh]) continue;
            frontier.push(make_pair(-currLength, currNeigh));
        }

    }

    if(successfulEnd){
        cout << length << endl;
    }
    else{
        cout << -1 << endl;
    }

    return 0;
}
