#include<iostream>
#include<queue>
#include<vector>

using namespace std;

const int maxn = 2005;
vector< pair< pair<int,int>, int> > adj[maxn];

priority_queue< pair< pair<int,int>, int> > frontier;
bool used[maxn];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n, m;
    cin >> n >> m;

    for(int i=0; i<m; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        adj[a].push_back(make_pair(make_pair(b, c),d));
    }

    long long length = 0;
    frontier.push(make_pair(make_pair(0,1),0));

    bool successfulEnd = false;

    while(!frontier.empty()){
        int curr = frontier.top().first.second;
        int addLength = -frontier.top().first.first;
        int addMagic = frontier.top().second;
        frontier.pop();

        if(used[curr]) continue;
        used[curr] = true;

        if(addLength > 0) length += addLength;

        if(curr == n){
            successfulEnd = true;
            break;
        }

        for(int i=0; i<adj[curr].size(); i++){
            int currNeigh = adj[curr][i].first.first;
            int currLength = adj[curr][i].first.second;
            int currMagic = adj[curr][i].second;
            if(used[currNeigh]) continue;
            frontier.push(make_pair(make_pair(-(currLength-addMagic), currNeigh),currMagic));
        }

    }

    if(successfulEnd){
        cout << length << endl;
    }
    else{
        cout << -1 << endl;
    }

    return 0;
}
