#pragma GCC optimize ("O3")
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

const int MAXN = 2001;
const int INF = 2e9;

int n, m;
vector<pair<int, int>> adj[MAXN];

priority_queue<pair<int, int>> q;
bool processed[MAXN];
int dist[MAXN];

void dijkstra(int node) {
    for (int i = 1; i <= n; i++) dist[i] = INF;
    dist[node] = 0;
    q.push({0, node});
    while (!q.empty()) {
        int a = q.top().second; q.pop();
        if (processed[a]) continue;
        processed[a] = true;
        for (auto c: adj[a]) {
            int b = c.first, w = c.second;
            if (dist[a] + w < dist[b]) {
                dist[b] = dist[a] + w;
                q.push({-dist[b], b});
            }
        }
    }
}

void input() {
    cin >> n >> m;
    for (int i = 0, a, b, w, m; i < n; i++) {
        cin >> a >> b >> w >> m;
        adj[a].push_back({b, w});
    }
}

void solve() {
    dijkstra(1);
}

void output() {
    int ans = dist[n];
    if (ans == INF) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    input();
    solve();
    output();

    return 0;
}
