#pragma GCC optimize ("O3")
#include <iostream>
#include <vector>
#include <tuple>
#include <queue>
using namespace std;

const int MAXN = 2001;
const int INF = 2e9;

int n, m;
vector<tuple<int, int, int>> edges;

int dist[MAXN];

void bf(int node) {
    for (int i = 1; i <= n; i++) dist[i] = INF;
    dist[node] = 0;
    for (int i = 0; i < n; i++) {
        for (auto e: edges) {
            int a, b, w;
            tie(a, b, w) = e;
            dist[b] = min(dist[b], dist[a] + w);
        }
    }
}

queue<pair<int, int>> trQ;
bool visited[MAXN];

void bfs(int node) {
    visited[node] = true;
    trQ.push({node, 0});
    while (!trQ.empty()) {
        int head = trQ.front().first;
        int hm = trQ.front().second;
        trQ.pop();
        for (auto c: edges) {
            int b, w, m;
            tie(b, w, m) = c;
            if (visited[b]) continue;
            visited[b] = true;
            dist[b] = dist[head] - hm;
            trQ.push({b, hm + m});
        }
    }
}

void input() {
    cin >> n >> m;
    for (int i = 0, a, b, w, m; i < n; i++) {
        cin >> a >> b >> w >> m;
        if (b != n)
            w -= m;
        edges.push_back(make_tuple(a, b, w));
    }
}

void solve() {
    bfs(1);
    bf(1);
}

void output() {
    if (dist[n] == INF) {
        cout << -1 << endl;
    } else {
        cout << dist[n] << endl;
    }
    //system("pause");
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    input();
    solve();
    output();

    return 0;
}
