#include<iostream>
#include<queue>
#include<vector>
using namespace std;

int broiDarjavi;
int broiPatishta;

struct DanniZaSaseda{
    int doKoi;
    int daljinaPat;
    int magicheskaSila;
};

vector<DanniZaSaseda> sasedstvo[2048];

bool imaLiPatDoKraq(int nachalo, int krai){
    bool visited[2048];

    for(int i = 0; i <= broiDarjavi; i++){
        visited[i] = false;
    }

    queue<int> q;
    q.push(nachalo);

    while(q.empty() == false){
        int naiOtpred = q.front();
        q.pop();

        if(visited[naiOtpred] == true){
            continue;
        }

        visited[naiOtpred] = true;
        if(naiOtpred == krai){
            break;
        }

        for(int i = 0; i < (int)sasedstvo[naiOtpred].size(); i++){
            q.push(sasedstvo[naiOtpred][i].doKoi);
        }
    }

    return visited[krai];
}

struct DanniZaMomenta{
    int kadeSme;
    int izminatPat;
    int kolkoMagiqImame;

    DanniZaMomenta(int kadeSme, int izminatPat, int kolkoMagiqImame)
        : kadeSme(kadeSme), izminatPat(izminatPat), kolkoMagiqImame(kolkoMagiqImame)
    {

    }
};

struct koiEPoNapred{
    bool operator()(DanniZaMomenta const& a, DanniZaMomenta const& b)
    {
        return a.izminatPat > b.izminatPat;
    }
};

int naiKasiqPatDoKraq(int start, int krai){

    priority_queue<DanniZaMomenta, vector<DanniZaMomenta>, koiEPoNapred> q;

    q.push({start, 0, 0});

    int otgovor = -1;

    while(q.empty() == false){
        DanniZaMomenta naiOtpred = q.top();
        q.pop();

        if(naiOtpred.kadeSme == krai){
            otgovor = naiOtpred.izminatPat;
            break;
        }

        for(int i = 0; i < (int)sasedstvo[naiOtpred.kadeSme].size(); i++){
            /*for(int sKolkoMagiq = 0; sKolkoMagiq <= min(naiOtpred.kolkoMagiqImame, sasedstvo[naiOtpred.kadeSme][i].daljinaPat); sKolkoMagiq++){
                q.push({sasedstvo[naiOtpred.kadeSme][i].doKoi,
                        naiOtpred.izminatPat + sasedstvo[naiOtpred.kadeSme][i].daljinaPat - sKolkoMagiq,
                        naiOtpred.kolkoMagiqImame - sKolkoMagiq + sasedstvo[naiOtpred.kadeSme][i].magicheskaSila});
            }*/

            q.push({sasedstvo[naiOtpred.kadeSme][i].doKoi, naiOtpred.izminatPat + sasedstvo[naiOtpred.kadeSme][i].daljinaPat, 0});
        }
    }

    return otgovor;
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiDarjavi>>broiPatishta;

    for(int i = 0; i < broiPatishta; i++){
        int otKade;
        int doKade;
        int daljina;
        int magiq;

        cin>>otKade>>doKade>>daljina>>magiq;

        sasedstvo[otKade].push_back({doKade, daljina, magiq});
    }

    if(imaLiPatDoKraq(1, broiDarjavi) == false){
        cout<<-1<<endl;
        return 0;
    }

    int otgovor = naiKasiqPatDoKraq(1, broiDarjavi);

    cout<<otgovor<<endl;

    return 0;
}
