#include<iostream>
#include<queue>
#include<vector>
using namespace std;

int broiDarjavi;
int broiPatishta;

struct DanniZaSaseda{
    int doKoi;
    int daljinaPat;
    int magicheskaSila;
};

vector<DanniZaSaseda> sasedstvo[2048];

bool visited[2048];

bool imaLiPatDoKraq(int nachalo, int krai){

    for(int i = 0; i <= broiDarjavi; i++){
        visited[i] = false;
    }

    //cout<<"qwerty"<<endl;

    queue<int> q;
    q.push(nachalo);

    while(q.empty() == false){
        int naiOtpred = q.front();
        q.pop();

        if(visited[naiOtpred] == true){
            continue;
        }

        visited[naiOtpred] = true;
        if(naiOtpred == krai){
            break;
        }

        for(int i = 0; i < (int)sasedstvo[naiOtpred].size(); i++){
            q.push(sasedstvo[naiOtpred][i].doKoi);
        }
    }

    return visited[krai];
}

struct DanniZaMomenta{
    int kadeSme;
    int izminatPat;
    int kolkoMagiqImame;

    DanniZaMomenta(int kadeSme, int izminatPat, int kolkoMagiqImame)
        : kadeSme(kadeSme), izminatPat(izminatPat), kolkoMagiqImame(kolkoMagiqImame)
    {

    }
};

struct koiEPoNapred{
    bool operator()(DanniZaMomenta const& a, DanniZaMomenta const& b)
    {
        return a.izminatPat - a.kolkoMagiqImame > b.izminatPat - b.kolkoMagiqImame;
    }
};

int naiKasPatDo[2048];
int naiKasPatMinusMagiqDo[2048];

int naiKasiqPatDoKraq(int start, int krai){

    for(int i = 0; i <= broiDarjavi; i++){
        naiKasPatDo[i] = 1000000007;
        naiKasPatMinusMagiqDo[i] = 1000000007;
    }

    priority_queue<DanniZaMomenta, vector<DanniZaMomenta>, koiEPoNapred> q;

    q.push({start, 0, 0});

    while(q.empty() == false){
        DanniZaMomenta naiOtpred = q.top();
        q.pop();

        //cout<<naiOtpred.kadeSme<<" "<<naiOtpred.izminatPat<<" "<<naiOtpred.kolkoMagiqImame<<endl;

        if(naiOtpred.izminatPat - naiOtpred.kolkoMagiqImame >= naiKasPatDo[krai]){
            break;
        }

        for(int i = 0; i < (int)sasedstvo[naiOtpred.kadeSme].size(); i++){
            for(int sKolkoMagiq = 0; sKolkoMagiq <= min(naiOtpred.kolkoMagiqImame, sasedstvo[naiOtpred.kadeSme][i].daljinaPat); sKolkoMagiq++){

                int sledvasht = sasedstvo[naiOtpred.kadeSme][i].doKoi;
                int novPat = naiOtpred.izminatPat + sasedstvo[naiOtpred.kadeSme][i].daljinaPat - sKolkoMagiq;
                int novaMagiq = naiOtpred.kolkoMagiqImame - sKolkoMagiq + sasedstvo[naiOtpred.kadeSme][i].magicheskaSila;

                if(naiKasPatDo[sledvasht] < novPat && naiKasPatMinusMagiqDo[sledvasht] < novPat - novaMagiq){

                }else{
                    q.push({sledvasht, novPat, novaMagiq});
                    naiKasPatDo[sledvasht] = min(naiKasPatDo[sledvasht], novPat);
                    naiKasPatMinusMagiqDo[sledvasht] = min(naiKasPatMinusMagiqDo[sledvasht], novaMagiq);
                }
            }

            //q.push({sasedstvo[naiOtpred.kadeSme][i].doKoi, naiOtpred.izminatPat + sasedstvo[naiOtpred.kadeSme][i].daljinaPat, 0});
        }
    }

    return naiKasPatDo[krai];
}

int main(){

    cin>>broiDarjavi>>broiPatishta;

    for(int i = 0; i < broiPatishta; i++){
        int otKade;
        int doKade;
        int daljina;
        int magiq;

        cin>>otKade>>doKade>>daljina>>magiq;

        sasedstvo[otKade].push_back({doKade, daljina, magiq});
    }

    //cout<<"vavedohme gi"<<endl;

    //cout<<endl;

    if(imaLiPatDoKraq(1, broiDarjavi) == false){
        cout<<-1<<endl;
        return 0;
    }

    //cout<<"qwerty"<<endl;

    int otgovor = naiKasiqPatDoKraq(1, broiDarjavi);
    //int otgovor = -1;

    cout<<otgovor<<endl;

    return 0;
}
