#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx2")
#define endl "\n"

using namespace std;

struct edge
{
    int ver, w, magic;
    edge() { }
    edge(int ver, int w, int magic) :ver(ver), w(w), magic(magic) { }
    bool operator< (const edge &o) const
    {
        return w > o.w;
    }
};

const int N = 128, inf = 1e9;
int n, m;
vector<edge> v[N];
int path[N][N];
int d[N];

void floid()
{
    for(int k = 1; k <= n; ++k)
        for(int i = 1; i <= n; ++i)
            for(int j = 1; j <= n; ++j)
                path[i][j] = min(path[i][j], path[i][k] + path[k][j]);
}

void dijkstra()
{

    for(int i = 1; i <= n; ++i) d[i] = inf;
    d[1] = 0;
    //memset(used, 0, sizeof(used));
    queue<edge> q;
    q.push({1, 0, 0});
    while(!q.empty())
    {
        edge e = q.front();
        q.pop();
        if(e.w <= d[e.ver])
        {
            for(edge i : v[e.ver])
            {
                if(max(0, e.w + i.w - e.magic) < d[i.ver] || (max(0, e.w + i.w - e.magic - i.magic) < d[i.ver] && e.w + i.w - e.magic - i.magic > -100 && i.ver != n))
                {
                    if(e.w + i.w > e.magic)
                    {
                        d[i.ver] = e.w + i.w - e.magic;
                        q.push({i.ver, e.w + i.w - e.magic, i.magic});
                    }
                    else
                    {
                        d[i.ver] = 0;
                        q.push({i.ver, 0, e.magic - e.w - i.w + i.magic});
                    }
                }
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int x, y, w, magic;
    cin >> n >> m;

    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= n; ++j) path[i][j] = inf;
    for(int i = 0; i < m; ++i)
    {
        cin >> x >> y >> w >> magic;
        path[x][y] = min(path[x][y], w);
        //cout << x << " " << y << " " << w << endl;
        v[x].push_back({y, w, magic});
    }

    dijkstra();
    //for(int i = 1; i <= n; ++i, cout << endl)
    //    for(int j = 1; j <= n; ++j) cout << path[i][j] << " ";
    if(d[n] == inf) cout << -1 << endl;
    else cout << d[n] << endl;
    return 0;
}
/*
7 8
1 2 1 0
2 4 1 0
4 6 1 0
6 7 3 0
1 3 5 0
3 5 2 0
5 7 3 0
3 4 3 0
*/
