#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N;
vector<int> Q;

void read() {
    cin >> N;

    Q.resize(N);
    for (int &i : Q) {
        cin >> i;
    }
}

void solve() {
    vector<int> fact(N + 1);
    fact[0] = 1;
    for (int i = 1; i <= N; i++) {
        fact[i] = (1ll * fact[i - 1] * i) % MOD;
    }

    int answer = 0;
    for (int mask = 0; mask < (1 << (N - 2)); mask++) {
        vector<int> perm(N, -1);
        bool ok = true;
        perm[1] = Q[0];
        perm[N - 2] = Q[N - 1];

        for (int i = 1; i < N - 1; i++) {
            if (mask & (1 << (i - 1))) {
                if (perm[i - 1] != -1 && perm[i - 1] != Q[i]) {
                    ok = false;
                    break;
                } else {
                    perm[i - 1] = Q[i];
                }
            } else {
                if (perm[i + 1] != -1 && perm[i + 1] != Q[i]) {
                    ok = false;
                    break;
                } else {
                    perm[i + 1] = Q[i];
                }
            }
        }

        if (!ok) {
            continue;
        }

        int numEmpty = 0;
        for (int i = 0; i < N; i++) {
            if (perm[i] == -1) {
                numEmpty++;
            }
        }

        set<int> s;
        for (int i = 0; i < N; i++) {
            if (perm[i] != -1) {
                if (s.count(perm[i])) {
                    ok = false;
                    break;
                } else {
                    s.emplace(perm[i]);
                }
            }
        }

        if (!ok) {
            continue;
        }

        answer += fact[numEmpty];
        if (answer >= MOD) {
            answer -= MOD;
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
