#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N, M, A, B, K;

void read() {
    cin >> N >> M >> A >> B >> K;
}

vector<vector<vector<int>>> dp;

long long f(int x, int y, int timeElapsed) {
    if (x > N || y > M) {
        return 0ll;
    }

    if (timeElapsed > K) {
        return 0ll;
    }

    if (x == N && y == M) {
        return 1ll;
    }

    if (dp[x][y][timeElapsed] != -1) {
        return dp[x][y][timeElapsed];
    }

    long long ways = 0;
    for (int dx = 0; dx <= A; dx++) {
        for (int dy = 0; dy <= B; dy++) {
            ways += f(x + dx, y + dy, timeElapsed + 1);
            if (ways >= MOD) {
                ways -= MOD;
            }
        }
    }

    return (dp[x][y][timeElapsed] = ways);
}

void solve() {
    dp.resize(N + 1, vector<vector<int>>(M + 1, vector<int>(K + 1, -1)));
    cout << f(0, 0, 0) << endl;
}

int main() {
    setIO();

    read();

    solve();
}
