#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N, M, A, B, K;

void read() {
    cin >> N >> M >> A >> B >> K;
}

int fastPow(int a, int b) {
    int answer = 1;
    while (b) {
        if (b & 1) {
            answer = (1ll * answer * a) % MOD;
        }

        a = (1ll * a * a) % MOD;
        b >>= 1;
    }

    return answer;
}

void solve() {
    vector<vector<vector<int>>> dp(2, vector<vector<int>>(N + 1, vector<int>(M + 1, 0)));
    dp[0][0][0] = 1;

    int answer = 0;
    for (int t = 1; t <= min(N + M, K); t++) {
        for (int i = 0; i <= N; i++) {
            for (int j = 0; j <= M; j++) {
                dp[t & 1][i][j] = 0;

                for (int dx = 0; dx <= A; dx++) {
                    if (i - dx < 0) {
                        break;
                    }

                    for (int dy = 0; dy <= B; dy++) {
                        if (j - dy < 0) {
                            break;
                        }

                        if (!(dx + dy)) {
                            continue;
                        }

                        dp[t & 1][i][j] += dp[(t & 1) ^ 1][i - dx][j - dy];
                        if (dp[t & 1][i][j] >= MOD) {
                            dp[t & 1][i][j] -= MOD;
                        }
                    }
                }
            }
        }

        answer += ((1ll * dp[t & 1][N][M] * fastPow(t + 1, K - t)) % MOD);
        if (answer >= MOD) {
            answer -= MOD;
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
