#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

const int MOD = 1e9 + 7;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N, M;
vector<vector<int>> graph;

void read() {
    cin >> N >> M;

    graph.resize(N + 1, vector<int>(N + 1, 0));
    for (int i = 0; i < M; i++) {
        int A, B, C, D;
        cin >> A >> B >> C >> D;

        graph[A][B] = C;
    }
}

void solve() {
    vector<vector<int>> paths(N + 1, vector<int>(N + 1, 1e9));
    for (int i = 1; i <= N; i++) {
        for (int j = 1; j <= N; j++) {
            if (graph[i][j]) {
                paths[i][j] = graph[i][j];
            }
        }
    }

    for (int k = 1; k <= N; k++) {
        for (int i = 1; i <= N; i++) {
            for (int j = 1; j <= N; j++) {
                paths[i][j] = min(paths[i][j], paths[i][k] + paths[k][j]);
            }
        }
    }

    cout << (paths[1][N] == 1e9 ? -1 : paths[1][N]) << endl;
}

int main() {
    setIO();

    read();

    solve();
}
