#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct Edge {
    int from;
    int to;
    int length;
    int magicPoints;

    Edge(int from, int to, int length, int magicPoints) {
        this->from = from;
        this->to = to;
        this->length = length;
        this->magicPoints = magicPoints;
    }
};

struct State {
    int node;
    int dist;
    int magicPoints;

    State(int node, int dist, int magicPoints) {
        this->node = node;
        this->dist = dist;
        this->magicPoints = magicPoints;
    }

    bool operator <(const State &rhs) const {
        if (this->dist == rhs.dist) {
            return (this->magicPoints < rhs.magicPoints);
        }

        return (this->dist > rhs.dist);
    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int N, M;
vector<Edge> edges;
vector<vector<int>> IDList;

void read() {
    cin >> N >> M;

    IDList.resize(N + 1);
    for (int i = 0; i < M; i++) {
        int A, B, C, D;
        cin >> A >> B >> C >> D;

        edges.emplace_back(A, B, C, D);
        IDList[A].emplace_back(edges.size() - 1);
    }
}

vector<int> minDist;

void dikstra(int from) {
    minDist.resize(N + 1, 1e9);
    minDist[from] = 0;

    priority_queue<State> q;
    q.emplace(from, 0, 0);
    while (!q.empty()) {
        State now = q.top();
        q.pop();

        if (minDist[now.node] < now.dist) {
            continue;
        }

        for (int edgeID : IDList[now.node]) {
            Edge &edge = edges[edgeID];

            if (edge.from == edge.to && edge.magicPoints > edge.length) {
                for (int i = 1; i <= N; i++) {
                    minDist[i] = min(minDist[i], now.dist + edge.length);
                }
            } else {
                if (now.magicPoints >= edge.length) {
                    if (minDist[edge.to] > now.dist) {
                        minDist[edge.to] = now.dist;
                        q.emplace(edge.to, minDist[edge.to], now.magicPoints - edge.length + edge.magicPoints);
                    }
                } else {
                    int l = edge.length - now.magicPoints;
                    if (minDist[edge.to] > now.dist + l) {
                        minDist[edge.to] = now.dist + l;
                        q.emplace(edge.to, minDist[edge.to], edge.magicPoints);
                    }
                }
            }
        }
    }
}

void solve() {
    dikstra(1);
    cout << minDist[N] << endl;
}

int main() {
    setIO();

    read();

    solve();
}
